from plotly.subplots import make_subplots
import plotly.graph_objects as go
import pandas as pd
from datetime import datetime

################################################################################################

#read csv file with data for df for each subplot

#read data to df_PSA dataframe and convert string date to datetime date for subplot(1,1)
df_PSA = pd.read_csv(
     r'C:\DataScienceSamples\csv_data_for_candlestick\PSA_with_observed_prices_for_plotly.csv')
df_PSA['date'] = pd.to_datetime(df_PSA['date'])
print(df_PSA)

#read data to df_NEE dataframe and convert string date to datetime date for subplot(1,2)
df_NEE = pd.read_csv(
     r'C:\DataScienceSamples\csv_data_for_candlestick\NEE_with_observed_prices_for_plotly.csv')
df_NEE['date'] = pd.to_datetime(df_NEE['date'])
print(df_NEE)

#read data to df_UNP dataframe and convert string date to datetime date for subplot(2,1)
df_UNP = pd.read_csv(
     r'C:\DataScienceSamples\csv_data_for_candlestick\UNP_with_observed_prices_for_plotly.csv')
df_UNP['date'] = pd.to_datetime(df_UNP['date'])
print(df_UNP)

#read data to df_SPY dataframe and convert string date to datetime date for subplot(2,2) 
df_SPY = pd.read_csv(
     r'C:\DataScienceSamples\csv_data_for_candlestick\SPY_with_observed_prices_for_plotly.csv')
df_SPY['date'] = pd.to_datetime(df_SPY['date'])
print(df_SPY)

################################################################################################

#specify subplot grid
fig = make_subplots(rows=2, cols=2,
                    subplot_titles=[
                    "Observed PSA Prices",
                    "Observed NEE Prices",
                    "Observed UNP Prices",
                    "Observed SPY Prices"],
                    shared_xaxes=False)

#specify the traces in the grid
fig.append_trace(go.Candlestick(x=df_PSA['date'],
                open=df_PSA['open'],
                high=df_PSA['high'],
                low=df_PSA['low'],
                close=df_PSA['close']),
                row=1, col=1)

fig.append_trace(go.Candlestick(x=df_NEE['date'],
                open=df_NEE['open'],
                high=df_NEE['high'],
                low=df_NEE['low'],
                close=df_NEE['close']),
                row=1, col=2)

fig.append_trace(go.Candlestick(x=df_UNP['date'],
                open=df_UNP['open'],
                high=df_UNP['high'],
                low=df_UNP['low'],
                close=df_UNP['close']),
                row=2, col=1)

fig.append_trace(go.Candlestick(x=df_SPY['date'],
                open=df_SPY['open'],
                high=df_SPY['high'],
                low=df_SPY['low'],
                close=df_SPY['close']),
                row=2, col=2)

#update subplot grid with parameter settings
fig.update_layout(title_text="Two-by-two Candlestick Subplots")
fig.update_xaxes(rangeslider_visible=False)
fig.update_layout(showlegend=False)


#show figure with subplot grid for candlestick charts
fig.show()
