#make library references
import plotly.graph_objects as go
import pandas as pd
from datetime import datetime

#########################################################################

#read data to df dataframe and convert string date to datetime date
df = pd.read_csv(
     r'C:\DataScienceSamples\csv_data_for_candlestick\PSA_with_observed_prices_for_plotly.csv')
df['date'] = pd.to_datetime(df['date'])

print(df)

#########################################################################

#chart df dataframe column values (observed prices) as candlesticks
fig = go.Figure(data=[go.Candlestick(x=df['date'],
                open=df['open'],
                high=df['high'],
                low=df['low'],
                close=df['close'])])

fig.update_layout(
    title='Candlestick chart for observed PSA prices',
    yaxis_title='Price per share',
    xaxis_rangeslider_visible=True)

fig.show()
